lab_1/urls.py
from django.conf.urls import url
from django.urls import path
from .views import index,friend_list


urlpatterns = [
    path('', index, name='index'),
    path('friends/', friend_list, name='friends')
    # TODO Add friends path using friend_list Views
]

lab_2/urls.py
from django.conf.urls import url
from django.urls import path
from lab_2.views import index
from lab_2.views import xml
from lab_2.views import json

urlpatterns = [
    path('', index, name='index'),
    path('xml/',xml,name= 'xml'),
    path('json/',json, name = 'json')
    # TODO Add friends path using friend_list Views
]

lab_3/urls.py
from django.conf.urls import url
from django.urls import path
from lab_3.views import index,add_friend


urlpatterns = [
    path('', index, name='index'),
    path('add/', add_friend, name = 'add_friend')
]

lab_4/urls.py
from django.conf.urls import url
from django.urls import path
from lab_4.views import index
from lab_4.views import add_note
from lab_4.views import note_list


urlpatterns = [
    path('', index, name='index'),
    path('add-note/', add_note, name='add_note'),
    path('note-list/', note_list, name='note_list'),
    # TODO Add friends path using friend_list Views
]

lab_5/urls.py
from django.conf.urls import url
from django.urls import path
from lab_4.views import index
from lab_4.views import add_note
from lab_4.views import note_list

urlpatterns = [
    path('', index, name='index'),
    path('add-note/', add_note, name='add_note'),
    path('note-list/', note_list, name='note_list'),
    # TODO Add friends path using friend_list Views
]

praktikum/urls.py
from django.urls import path, re_path, include
from django.contrib import admin
import lab_1.urls as lab_1
import lab_2.urls as lab_2
import lab_3.urls as lab_3
import lab_4.urls as lab_4
import lab_5.urls as lab_5
from lab_1.views import index as index_lab1


urlpatterns = [
    path('admin/', admin.site.urls),
    path('lab-1/', include('lab_1.urls')),
    path('lab-2/', include('lab_2.urls')),
    path('lab-3/', include('lab_3.urls')),
    path('lab-4/', include('lab_4.urls')),
    path('lab-5/', include('lab_5.urls')),
    re_path(r'^$', index_lab1, name='index'),
     
]

lab_1/models.py
from django.db import models
# TODO Create Friend model that contains name, npm, and DOB (date of birth) here


class Friend(models.Model):
    name = models.CharField(max_length=30)
    npm = models.CharField(max_length = 30)
    dob = models.DateField(max_length=30) 
    # TODO Implement missing attributes in Friend model

lab_2/models.py
from django.db import models

# Create your models here.
class Note(models.Model):
    To = models.CharField(max_length=30)
    From = models.CharField(max_length=30)
    Title = models.TextField()
    message = models.TextField()

lab_3/models.py
from django.db import models

# Create your models here.

lab_4/models.py
from django.db import models

# Create your models here.

lab_5/models.py
from django.db import models

# Create your models here.

lab_3/forms.py
from django import forms
from lab_1.models import Friend


class FriendForm(forms.ModelForm):
    class Meta:
        model  = Friend
        fields = 'name','npm','dob'

        error_messages = {
            'required':'Please Type'
        }
        input_attrs = {
            'type':'text',
            'placeholder': 'Nama Anda''NPM Anda'
            
        }
        name = forms.CharField(label="",required = False, max_length = 30,widget= forms.TextInput(attrs = input_attrs))
        npm = forms.CharField(label="",required = False, max_length = 30,widget= forms.TextInput(attrs = input_attrs))
        dob = forms.DateField(label="",required = False)
        

lab_4/forms.py
from django import forms
from lab_2.models import Note


class NoteForm(forms.ModelForm):
    class Meta:
        model  = Note
        fields = 'To','From','Title','message'

        error_messages = {
            'required':'Please Type'
        }
        input_attrs = {
            'type':'text',
            'placeholder': 'Nama Penerima''Nama Pengirim''Judul''Masukkan Pesan'
            
        }
        To = forms.CharField(label="",required = False,widget= forms.TextInput(attrs = input_attrs))
        From = forms.CharField(label="",required = False,widget= forms.TextInput(attrs = input_attrs))
        Title = forms.CharField(label="",required = False, widget= forms.TextInput(attrs = input_attrs))
        message = forms.CharField(label="",required = False, widget= forms.TextInput(attrs = input_attrs))
    
        

lab_1/views.py
from django.shortcuts import render
from datetime import datetime, date
from .models import Friend

mhs_name = 'Dominikus Kern Bunardi'  # TODO Implement this
curr_year = int(datetime.now().strftime("%Y"))
birth_date = date(2002,8,27)  # TODO Implement this, format (Year, Month, Date)
npm = '2006464423' # TODO Implement this


def index(request):
    response = {'name': mhs_name,
                'age': calculate_age(birth_date.year),
                'npm': npm}
    return render(request, 'index_lab1.html', response)


def calculate_age(birth_year):
    return curr_year - birth_year if birth_year <= curr_year else 0


def friend_list(request):
    friends = Friend.objects.all().values()# TODO Implement this
    response = {'friends': friends}
    return render(request, 'friend_list_lab1.html', response)

lab_2/views.py
from django.http.response import HttpResponse
from django.core import serializers
from django.shortcuts import render
from lab_2.models import Note

def index(request):
    notes = Note.objects.all().values()
    response = {'notes' : notes}
    return render(request, "lab2.html", response)

def xml(request):
    data = serializers.serialize('xml', Note.objects.all())
    return HttpResponse(data, content_type="application/xml")

def json(request):
    data = serializers.serialize('json', Note.objects.all())
    return HttpResponse(data, content_type="application/json")
    

lab_3/views.py
from django.contrib.auth.decorators import login_required
from django.shortcuts import redirect, render
from lab_1.models import Friend 
from lab_3.forms import FriendForm

# Create your views here.
@login_required(login_url='/admin/login/')

def index(request):
    friends = Friend.objects.all().values()
    response = {'friends': friends}
    return render(request, 'lab3_index.html', response)
    
@login_required(login_url='/admin/login/')
def add_friend(request):
    context = {}
    form = FriendForm(request.POST or None, request.FILES or None)
      
    # check if form data is valid
    if form.is_valid():
        # save the form data to model
        form.save()
        return redirect('index')
  
    context['form']= form
    return render(request, "lab3_form.html", context)

lab_4/views.py
from django.shortcuts import render,redirect
from lab_2.models import Note
from lab_4.forms import NoteForm
# Create your views here.
def index(request):
    notes = Note.objects.all().values()
    response = {'notes' : notes}
    return render(request, "lab4_index.html", response)
def add_note(request):
    context = {}
    form = NoteForm(request.POST or None, request.FILES or None)
        
    # check if form data is valid
    if form.is_valid():
        # save the form data to model
        form.save()
        return redirect('http://127.0.0.1:8000/lab-4/note-list/')
    context['form']= form
    return render(request, "lab4_form.html", context)  

def note_list(request):
    notes = Note.objects.all().values()
    response = {'notes' : notes}
    return render(request, "lab4_note_list.html", response)

lab_5/views.py
from django.shortcuts import render
from lab_2.models import Note
# Create your views here.
def index(request):
    notes = Note.objects.all().values()
    response = {'notes' : notes}
    return render(request, "lab5_index.html", response)

lab_1/templates/friend_list_lab1.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
  </head>
  <body>
    <table>
      <tr>
        <th>Name</th>
        <th>NPM</th>
        <th>DOB</th>
      </tr>
      <!-- TODO loop from Friend model -->
      
      {% if friends %}
        {% for f in friends %}
        <tr>
          <td>{{f.name}}</td>
          <td>{{f.npm}}</td>
          <td>{{f.dob}}</td>
        </tr>
        <br/>
        {% endfor %}
      {% endif %}  
      <!-- EXAMPLE SECTION -->
      <tr>
        <td>Asmara Nugi</td>
        <td>1706032156</td>
        <td>May 1, 1999</td>
      </tr>
      <tr>
        <td>Fadli Rais</td>
        <td>1706032370</td>
        <td>Sept 11, 1998</td>
      </tr> -->
      <!-- END SECTION
    </table>
  </body>
</html>

lab_1/templates/index_lab1.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>{{ name }}</title>
  </head>
  <body>
    <h1>Hello my name is {{ name }}</h1>
    <article>NPM : {{ npm }}</article>
    <article>I am {{ age }} years old</article>
  </body>
</html>

lab_2/templates/lab2.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Notes</title>
</head>
<body>
    <table border ="1">
        <tr bgcolor= 'lightyellow'>
            <th>to</th>
            <th>from</th>
            <th>title</th>
            <th>message</th>
        </tr>
        {% if notes %}
        {% for f in notes %}
        <tr>
            <td>{{f.To}}</td>
            <td>{{f.From}}</td>
            <td>{{f.Title}}</td>
            <td>{{f.message}}</td>
        </tr>
        <br/>
        {% endfor %}
    {% endif %}
    </table>
</body>
</html>

lab_3/templates/lab3_form.html
<!DOCTYPE html>
<html>
  <head>
    <title>Simple registration form</title>
    <link href="https://fonts.googleapis.com/css?family=Roboto:300,400,500,700" rel="stylesheet">
    <style>
      html, body {
      display: flex;
      justify-content: center;
      height: 100%;
      }
      body, div, h1, form, input, p { 
      padding: 0;
      margin: 0;
      outline: none;
      font-family: Roboto, Arial, sans-serif;
      font-size: 16px;
      color: #666;
      }
      h1 {
      padding: 10px 0;
      font-size: 32px;
      font-weight: 300;
      text-align: center;
      }
      hr {
      color: #a9a9a9;
      opacity: 0.3;
      }
      .main-block {
      max-width: 380px; 
      min-height: 280px; 
      padding: 10px 0;
      margin: auto;
      border-radius: 5px; 
      border: solid 1px #ccc;
      box-shadow: 1px 2px 5px rgba(0,0,0,.31); 
      background: #ebebeb; 
      }
      form {
      margin: 0 30px;
      }
      
      
      .btn-block {
      margin-top: 10px;
      text-align: center;
      }
      button {
      width: 100%;
      padding: 10px 0;
      margin: 10px auto;
      border-radius: 5px; 
      border: none;
      background: #1c87c9; 
      font-size: 14px;
      font-weight: 600;
      color: #fff;
      }
      button:hover {
      background: #26a9e0;
      }
    </style>
  </head>
  <body>
    <div class="main-block">
      <h1>Friend Form</h1>
      <form action="" method = "POST">
        {% csrf_token%}
        <hr>
        <div class= "account-type">
        Name : <input type="text" name = "name" placeholder="Nama Anda" maxlength="27" id="id_name"> <br><br>
        NPM : <input type="text" name = "npm" placeholder="NPM Anda" maxlength="27" id="id_npm"> <br><br>
        Date of Birth : <input type="date" name = "dob" id="id_dob"> <br>
        </div>
        <hr>
        <div class="btn-block">
          <button type="submit" href="/">Submit</button>
        </div>
      </form>
    </div>
  </body>
</html>

lab_3/templates/lab3_index.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
  </head>
  <body>
    <table border = "1">
      <tr>
        <th>Name</th>
        <th>NPM</th>
        <th>DOB</th>
      </tr>
      <!-- TODO loop from Friend model -->
      {% if friends %}
        {% for f in friends %}
        <tr>
          <td>{{f.name}}</td>
          <td>{{f.npm}}</td>
          <td>{{f.dob}}</td>
        </tr>
        {% endfor %}
      {% endif %}  
    </table>
  </body>
</html>  
    

lab_4/templates/lab4_form.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href = "{% static 'form.css' %}">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
    <title>Note Form</title>
</head>
<body>
  <nav class="navbar navbar-inverse">
    <div class="container-fluid">
      <div class="navbar-header">
        <a class="navbar-brand" href="http://127.0.0.1:8000/lab-4/add-note/">KernWeb</a>
      </div>
      <ul class="nav navbar-nav">
        <li class = "active"><a href="http://127.0.0.1:8000/lab-4/add-note/">Home</a></li>
        <li><a href="http://127.0.0.1:8000/lab-4/">List</a></li>
        <li><a href="http://127.0.0.1:8000/lab-4/note-list/">List of Card</a></li>
      </ul>
    </div>
  </nav>
    <div class = "form-container">
    <h2 class = "form-heading">Note Form</h2>
      <form action="" method = "POST">
        {% csrf_token%}
      
        <div class= "form-in">
        <div class = "input-field">
          <label>To </label>
          <input type="text" name = "To" placeholder="Nama Penerima"  class= "input"> <br><br>
        </div>
        <div class = "input-field">
          <label>From </label>
          <input type="text" name = "From" placeholder="Nama Pengirim"  class= "input"> <br><br>
        </div>
        <div class = "input-field">
          <label>Title </label>
          <input type="text" name = "Title" placeholder="Judul"  class= "input"> <br><br>
        </div>
        <div class = "input-field">
          <label>Message </label>
          <textarea class="textarea"name = "message" placeholder="Masukkan Pesan"  id="id_message"></textarea><br><br>
        </div>
        </div>
        
        <div class="btn-block">
          <button type="submit" href="/">Submit</button>
        </div>
      </form>
    </div>
</body>
</html>

lab_4/templates/lab4_index.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Notes</title>
    <link rel="stylesheet" href = "{% static 'index.css' %}">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
    
</head>
<body>
    <nav class="navbar navbar-inverse">
        <div class="container-fluid">
          <div class="navbar-header">
            <a class="navbar-brand" href="http://127.0.0.1:8000/lab-4/add-note/">KernWeb</a>
          </div>
          <ul class="nav navbar-nav">
            <li><a href="http://127.0.0.1:8000/lab-4/add-note/">Home</a></li>
            <li class= "active"><a href="http://127.0.0.1:8000/lab-4/">List</a></li>
            <li><a href="http://127.0.0.1:8000/lab-4/note-list/">List of Card</a></li>
          </ul>
        </div>
      </nav>
     
    <div class = "table-container" >
    <h2 class = "table-heading">Table of Notes</h2>
    <table>
        <thead>
        <tr>
            <th>To</th>
            <th>From</th>
            <th>Title</th>
            <th>Message</th>
        </tr>
        </thead>
        </tbody>
        {% if notes %}
            {% for f in notes %}
            <tr>
                <td data-heading = "to">{{f.To}}</td>
                <td data-heading = "from">{{f.From}}</td>
                <td data-heading = "title">{{f.Title}}</td>
                <td data-heading = "message">{{f.message}}</td>
            </tr>
            {% endfor %}
        {% endif %}
        </tbody>
    </table>
    </div>
</body>
</html>

lab_4/templates/lab4_note_list.html
{% load static%}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href = "{% static 'list.css'%}">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
    <title>Note List</title>
</head>
<body>

<nav class="navbar navbar-inverse">
    <div class="container-fluid">
      <div class="navbar-header">
        <a class="navbar-brand" href="http://127.0.0.1:8000/lab-4/add-note/">KernWeb</a>
      </div>
      <ul class="nav navbar-nav">
        <li><a href="http://127.0.0.1:8000/lab-4/add-note/">Home</a></li>
        <li><a href="http://127.0.0.1:8000/lab-4/">List</a></li>
        <li class="active"><a href="http://127.0.0.1:8000/lab-4/note-list/">List of Card</a></li>
      </ul>
    </div>
  </nav>

<div class="wrapper" >
    {% if notes %}
        {% for f in notes %}
        <div class= "box">
            <div class="card">
                <div class = "front">
                    <h3>{{f.Title}}</h3><br>
                    <p>To : {{f.To}}</p><br>
                    <p>From: {{f.From}}</p><br>
                </div>
                <div class = "back">
                    <p>{{f.message}}</p>
                </div>
            </div>
        </div>
        {% endfor %}
    {% endif %}
</div>
  
</body>
</html>

lab_5/templates/lab5_index.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Notes</title>
</head>
<body>
    <table border ="1">
        <tr bgcolor= 'lightyellow'>
            <th>to</th>
            <th>from</th>
            <th>title</th>
            <th>message</th>
            <th>action</th>
        </tr>
        {% if notes %}
        {% for f in notes %}
        <tr>
            <td>{{f.To}}</td>
            <td>{{f.From}}</td>
            <td>{{f.Title}}</td>
            <td>{{f.message}}</td>
          
        </tr>
        <br/>
        {% endfor %}
    {% endif %}
    </table>
</body>
</html>